---
title: Using WebRTC data channels
slug: Web/API/WebRTC_API/Using_data_channels
tags:
  - Communications
  - Data Transfer
  - Draft
  - Guide
  - NeedsContent
  - Networking
  - RTCDataChannel
  - WebRTC
  - WebRTC API
  - buffering
---
<p>{{WebRTCSidebar}}{{draft}}</p>

<p>Once you've established a WebRTC peer connection using the {{domxref("RTCPeerConnection")}} interface, you're able to send and receive media data between the two peers on the connection. But there's a lot more you can do with WebRTC. <span class="seoSummary">In this guide, we'll examine how to add a data channel to a peer connection, which can then be used to securely exchange arbitrary data; that is, any kind of data we wish, in any format we choose.</span></p>

<div class="note">
<p>Since all WebRTC components are required to use encryption, any data transmitted on an <code>RTCDataChannel</code> is automatically secured using Datagram Transport Layer Security (<strong>DTLS</strong>). See {{anch("Security")}} below for more information.</p>
</div>

<h2 id="Creating_a_data_channel">Creating a data channel</h2>

<p>The underlying data transport used by the {{domxref("RTCDataChannel")}} can be created in one of two ways:</p>

<ul>
 <li>Let WebRTC create the transport and announce it to the remote peer for you (by causing it to receive a {{event("datachannel")}} event). This is the easy way, and works for a wide variety of use cases, but may not be flexible enough for your needs.</li>
 <li>Write your own code to negotiate the data transport and write your own code to signal to the other peer that it needs to connect to the new channel.</li>
</ul>

<p>Let's look at each of these cases, starting with the first, which is the most common.</p>

<h3 id="Automatic_negotiation">Automatic negotiation</h3>

<p>Often, you can allow the peer connection to handle negotiating the {{domxref("RTCDataChannel")}} connection for you. To do this, call</p>

<p>{{domxref("RTCPeerConnection.createDataChannel", "createDataChannel()")}} without specifying a value for the {{domxref("RTCDataChannelInit.negotiated", "negotiated")}} property, or specifying the property with a value of <code>false</code>. This will automatically trigger the <code>RTCPeerConnection</code> to handle the negotiations for you, causing the remote peer to create a data channel and linking the two together across the network.</p>

<p>The <code>RTCDataChannel</code> object is returned immediately by <code>createDataChannel()</code>; you can tell when the connection has been made successfully by watching for the {{domxref("RTCDataChannel.open_event", "open")}} event to be sent to the <code>RTCDataChannel</code>.</p>

<pre class="brush: js">let dataChannel = pc.createDataChannel("MyApp Channel");

dataChannel.addEventListener("open", (event) =&gt; {
  beginTransmission(dataChannel);
});
</pre>

<h3 id="Manual_negotiation">Manual negotiation</h3>

<p>To manually negotiate the data channel connection, you need to first create a new {{domxref("RTCDataChannel")}} object using the {{domxref("RTCPeerConnection.createDataChannel", "createDataChannel()")}} method on the {{domxref("RTCPeerConnection")}}, specifying in the options a {{domxref("RTCDataChannelInit.negotiated", "negotiated")}} property set to <code>true</code>. This signals to the peer connection to not attempt to negotiate the channel on your behalf.</p>

<p>Then negotiate the connection out-of-band, using a web server or other means. This process should signal to the remote peer that it should create its own <code>RTCDataChannel</code> with the <code>negotiated</code> property also set to <code>true</code>, using the same {{domxref("RTCDataChannel.id", "id")}}. This will link the two objects across the <code>RTCPeerConnection</code>.</p>

<pre class="brush: js">let dataChannel = pc.createDataChannel("MyApp Channel", {
  negotiated: true
});

dataChannel.addEventListener("open", (event) =&gt; {
  beginTransmission(dataChannel);
});

requestRemoteChannel(dataChannel.id);</pre>

<p>In this code snippet, the channel is created with <code>negotiated</code> set to <code>true</code>, then a function called <code>requestRemoteChannel()</code> is used to trigger negotiation, to create a remote channel with the same ID as the local channel.</p>

<p>Doing this lets you create data channels with each peer using different properties, and to create channels declaratively by using the same value for <code>id</code>.</p>

<h2 id="Buffering">Buffering</h2>

<p>WebRTC data channels support buffering of outbound data. This is handled automatically. While there's no way to control the size of the buffer, you can learn how much data is currently buffered, and you can choose to be notified by an event when the buffer starts to run low on queued data. This makes it easy to write efficient routines that make sure there's always data ready to send without over-using memory or swamping the channel completely.</p>

<p><strong>&lt;&lt;&lt;write more about using bufferedAmount, bufferedAmountLowThreshold, onbufferedamountlow, and bufferedamountlow here&gt;&gt;&gt;</strong></p>

<p>...</p>

<h2 id="Understanding_message_size_limits">Understanding message size limits</h2>

<p>For any data being transmitted over a network, there are size restrictions. At a fundamental level, the individual network packets can't be larger than a certain value (the exact number depends on the network and the transport layer being used). At the application level—that is, within the {{Glossary("user agent", "user agent's")}} implementation of WebRTC on which your code is running—the WebRTC implementation implements features to support messages that are larger than the maximum packet size on the network's transport layer.</p>

<p>This can complicate things, since you don't necessarily know what the size limits are for various user agents, and how they respond when a larger message is sent or received. Even when user agents share the same underlying library for handling Stream Control Transmission Protocol (SCTP) data, there can still be variations due to how the library is used. For example, both Firefox and Google Chrome use the <code><a href="https://github.com/sctplab/usrsctp">usrsctp</a></code> library to implement SCTP, but there are still situations in which data transfer on an <code>RTCDataChannel</code> can fail due to differences in how they call the library and react to errors it returns.</p>

<p>When two users running Firefox are communicating on a data channel, the message size limit is much larger than when Firefox and Chrome are communicating because Firefox implements a now deprecated technique for sending large messages in multiple SCTP messages, which Chrome does not. Chrome will instead see a series of messages that it believes are complete, and will deliver them to the receiving <code>RTCDataChannel</code> as multiple messages.</p>

<p>Messages smaller than 16kiB can be sent without concern, as all major user agents handle them the same way. Beyond that, things get more complicated.</p>

<h3 id="Concerns_with_large_messages">Concerns with large messages</h3>

<p>Currently, it's not practical to use <code>RTCDataChannel</code> for messages larger than 64kiB (16kiB if you want to support cross-browser exchange of data). The problem arises from the fact that SCTP—the protocol used for sending and receiving data on an <code>RTCDataChannel</code>—was originally designed for use as a signaling protocol. It was expected that messages would be relatively small. Support for messages larger than the network layer's {{interwiki("wikipedia", "Maximum transmission unit", "MTU")}} was added almost as an afterthought, in case signaling messages needed to be larger than the MTU. This feature requires that each piece of the message have consecutive sequence numbers, so they have to be transmitted one after another, without any other data interleaved between them.</p>

<p>This eventually became a problem. Over time, various applications (including those implementing WebRTC) began to use SCTP to transmit larger and larger messages. Eventually it was realized that when the messages become too large, it's possible for the transmission of a large message to block all other data transfers on that data channel—including critical signaling messages.</p>

<p>This will become an issue when browsers properly support the current standard for supporting larger messages—the end-of-record (EOR) flag that indicates when a message is the last one in a series that should be treated as a single payload. This is implemented in Firefox 57, but is not yet implemented in Chrome (see <a href="https://bugs.chromium.org/p/webrtc/issues/detail?id=7774">Chromium Bug 7774</a>). With EOR support in place, <code>RTCDataChannel</code> payloads can be much larger (officially up to 256kiB, but Firefox's implementation caps them at a whopping 1GiB). Even at 256kiB, that's large enough to cause noticeable delays in handling urgent traffic. If you go even larger, the delays can become untenable unless you are certain of your operational conditions.</p>

<p>In order to resolve this issue, a new system of <strong>stream schedulers</strong> (usually referred to as the "SCTP ndata specification") has been designed to make it possible to interleave messages sent on different streams, including streams used to implement WebRTC data channels. This <a href="https://tools.ietf.org/html/draft-ietf-tsvwg-sctp-ndata">proposal</a> is still in IETF draft form, but once implemented, it will make it possible to send messages with essentially no size limitations, since the SCTP layer will automatically interleave the underlying sub-messages to ensure that every channel's data has the opportunity to get through.</p>

<p>Firefox support for ndata is in the process of being implemented; see {{bug(1381145)}} to track it becoming available for general use. The Chrome team is tracking their implementation of ndata support in <a href="https://bugs.chromium.org/p/webrtc/issues/detail?id=5696">Chrome Bug 5696</a>.</p>

<div class="originaldocinfo">
<p>Much of the information in this section is based in part on the blog post <a href="https://lgrahl.de/articles/demystifying-webrtc-dc-size-limit.html">Demystifyijng WebRTC's Data Channel Message Size Limitations</a>, written by Lennart Grahl. He goes into a bit more detail there, but as browsers have been updated since then some of it may be out-of-date. In addition, as time goes by, it will become more so, especially once EOR and ndata support are fully integrated in the major browsers.</p>
</div>

<h2 id="Security">Security</h2>

<p>All data transferred using WebRTC is encrypted. In the case of <code>RTCDataChannel</code>, the encryption used is Datagram Transport Layer Security (DTLS), which is based on <a href="/en-US/docs/Web/Security/Transport_Layer_Security">Transport Layer Security</a> (TLS). Since TLS is used to secure every HTTPS connection, any data you send on a data channel is as secure as any other data sent or received by the user's browser.</p>

<p>More fundamentally, since WebRTC is a peer-to-peer connection between two user agents, the data never passes through the web or application server. This reduces opportunities to have the data intercepted.</p>
